Index: /LMDZ6/trunk/libf/dyn3dmem/vlsplt_loc.F
===================================================================
--- /LMDZ6/trunk/libf/dyn3dmem/vlsplt_loc.F	(revision 4049)
+++ /LMDZ6/trunk/libf/dyn3dmem/vlsplt_loc.F	(revision 4050)
@@ -14,5 +14,5 @@
 c   --------------------------------------------------------------------
       USE parallel_lmdz
-      USE infotrac, ONLY : nqtot,nqfils,nqdesc,iqfils, ! CRisi                 &
+      USE infotrac, ONLY : nqtot,tracers, ! CRisi                 &
      &                     qperemin,masseqmin,ratiomin ! MVals et CRisi
       IMPLICIT NONE
@@ -330,32 +330,29 @@
 ! Il faut faire ça avant d'avoir mis à jour q et masse
 
-       if (nqfils(iq).gt.0) then
-       do ifils=1,nqdesc(iq)
-       !do ifils=1,nqfils(iq) ! modif C Risi 22nov2020
+      do ifils=1,tracers(iq)%nqDescen
         ! attention: comme Ratio est utilisé comme q dans l'appel
         ! recursif, il doit contenir à lui seul tous les indices de tous
         ! les descendants!
-         iq2=iqfils(ifils,iq)
-c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
-         DO l=1,llm
+        iq2=tracers(iq)%iqDescen(ifils)
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+        DO l=1,llm
           DO ij=ijb,ije
-           ! On a besoin de q et masse seulement entre ijb et ije. On ne
-           ! les calcule donc que de ijb à ije
-           !MVals: veiller a ce qu'on n'ait pas de denominateur nul
-           masse(ij,l,iq2)=max(masse(ij,l,iq)*q(ij,l,iq),masseqmin)
-           if (q(ij,l,iq).gt.qperemin) then ! modif 13 nov 2020
-             Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)
-           else
-             Ratio(ij,l,iq2)=ratiomin
-           endif
+            ! On a besoin de q et masse seulement entre ijb et ije. On ne
+            ! les calcule donc que de ijb à ije
+            !MVals: veiller a ce qu'on n'ait pas de denominateur nul
+            masse(ij,l,iq2)=max(masse(ij,l,iq)*q(ij,l,iq),masseqmin)
+            if (q(ij,l,iq).gt.qperemin) then ! modif 13 nov 2020
+              Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)
+            else
+              Ratio(ij,l,iq2)=ratiomin
+            endif
           enddo   
-         enddo
-c$OMP END DO NOWAIT
-        enddo !do ifils=1,nqdesc(iq)
-        do ifils=1,nqfils(iq)
-         iq2=iqfils(ifils,iq)
-         call vlx_loc(Ratio,pente_max,masse,u_mq,ijb_x,ije_x,iq2)
-        enddo !do ifils=1,nqfils(iq)
-      endif !if (nqfils(iq).gt.0) then
+        enddo
+c$OMP END DO NOWAIT
+      enddo !do ifils=1,tracers(iq)%nqDescen
+      do ifils=1,tracers(iq)%nqChilds
+        iq2=tracers(iq)%iqDescen(ifils)
+        call vlx_loc(Ratio,pente_max,masse,u_mq,ijb_x,ije_x,iq2)
+      enddo
 ! end CRisi
 
@@ -383,20 +380,17 @@
       ! On calcule q entre ijb+1 et ije -> on fait pareil pour ratio 
       ! puis on boucle en longitude
-      if (nqfils(iq).gt.0) then  
-       do ifils=1,nqdesc(iq)
-       !do ifils=1,nqfils(iq) ! modif C Risi 22nov2020
-         iq2=iqfils(ifils,iq)  
+      do ifils=1,tracers(iq)%nqDescen
+        iq2=tracers(iq)%iqDescen(ifils)
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)   
-         DO l=1,llm
+        DO l=1,llm
           DO ij=ijb+1,ije
             q(ij,l,iq2)=q(ij,l,iq)*Ratio(ij,l,iq2)            
           enddo
           DO ij=ijb+iip1-1,ije,iip1
-             q(ij-iim,l,iq2)=q(ij,l,iq2)
-          enddo ! DO ij=ijb+iip1-1,ije,iip1
-         enddo !DO l=1,llm
-c$OMP END DO NOWAIT
-        enddo !do ifils=1,nqdesc(iq)
-      endif !if (nqfils(iq).gt.0) then
+            q(ij-iim,l,iq2)=q(ij,l,iq2)
+          enddo
+        enddo
+c$OMP END DO NOWAIT
+      enddo
 
       !write(*,*) 'vlsplt 399: iq,ijb_x=',iq,ijb_x
@@ -422,5 +416,5 @@
 c   --------------------------------------------------------------------
       USE parallel_lmdz
-      USE infotrac, ONLY : nqtot,nqfils,nqdesc,iqfils, ! CRisi                 &
+      USE infotrac, ONLY : nqtot,tracers, ! CRisi                 &
      &                     qperemin,masseqmin,ratiomin ! MVals et CRisi    
       USE comconst_mod, ONLY: pi
@@ -732,5 +726,5 @@
 ! CRisi: appel récursif de l'advection sur les fils.
 ! Il faut faire ça avant d'avoir mis à jour q et masse
-      !write(*,*) 'vly 689: iq,nqfils(iq)=',iq,nqfils(iq) 
+      !write(*,*) 'vly 689: iq,nqDesc(iq)=',iq,tracers(iq)%nqDescen
 
       ijb=ij_begin-2*iip1
@@ -743,35 +737,32 @@
       if (pole_sud)  ijem=ij_end
 
-      if (nqfils(iq).gt.0) then  
-       do ifils=1,nqdesc(iq)
-       !do ifils=1,nqfils(iq) ! modif C Risi 22nov2020
-         iq2=iqfils(ifils,iq)
+      do ifils=1,tracers(iq)%nqDescen
+        iq2=tracers(iq)%iqDescen(ifils)
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK) 
-         DO l=1,llm
-          ! modif des bornes: CRisi 16 nov 2020
-          ! d'abord masse avec bornes corrigées
+        DO l=1,llm
+        ! modif des bornes: CRisi 16 nov 2020
+        ! d'abord masse avec bornes corrigées
           DO ij=ijbm,ijem 
-           !MVals: veiller a ce qu'on n'ait pas de denominateur nul
-           masse(ij,l,iq2)=max(masse(ij,l,iq)*q(ij,l,iq),masseqmin)
-          enddo !DO ij=ijbm,ijem 
+          !MVals: veiller a ce qu'on n'ait pas de denominateur nul
+            masse(ij,l,iq2)=max(masse(ij,l,iq)*q(ij,l,iq),masseqmin)
+          enddo
 
           ! ensuite Ratio avec anciennes bornes
-         DO ij=ijb,ije
-           !MVals: veiller a ce qu'on n'ait pas de denominateur nul
-           if (q(ij,l,iq).gt.qperemin) then ! modif 13 nov 2020
-             Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)
-           else
-             Ratio(ij,l,iq2)=ratiomin  
-           endif     
+          DO ij=ijb,ije
+          !MVals: veiller a ce qu'on n'ait pas de denominateur nul
+            if (q(ij,l,iq).gt.qperemin) then ! modif 13 nov 2020
+              Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)
+            else
+              Ratio(ij,l,iq2)=ratiomin  
+            endif     
           enddo !DO ij=ijbm,ijem  
-         enddo !DO l=1,llm
-c$OMP END DO NOWAIT
-        enddo !do ifils=1,nqdesc(iq)
-
-        do ifils=1,nqfils(iq)
-         iq2=iqfils(ifils,iq)
-         call vly_loc(Ratio,pente_max,masse,qbyv,iq2)
-        enddo !do ifils=1,nqfils(iq)
-      endif !if (nqfils(iq).gt.0) then
+        enddo !DO l=1,llm
+c$OMP END DO NOWAIT
+      enddo
+
+      do ifils=1,tracers(iq)%nqChilds
+        iq2=tracers(iq)%iqDescen(ifils)
+        call vly_loc(Ratio,pente_max,masse,qbyv,iq2)
+      enddo
 ! end CRisi
       
@@ -862,16 +853,14 @@
 !      if (pole_sud)  ije=ij_end
 
-      if (nqfils(iq).gt.0) then  
-       do ifils=1,nqdesc(iq)
-         iq2=iqfils(ifils,iq)  
+      do ifils=1,tracers(iq)%nqDescen
+        iq2=tracers(iq)%iqDescen(ifils)
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)   
-         DO l=1,llm
+        DO l=1,llm
           DO ij=ijb,ije
             q(ij,l,iq2)=q(ij,l,iq)*Ratio(ij,l,iq2)            
           enddo
-         enddo
-c$OMP END DO NOWAIT
-        enddo !do ifils=1,nqdesc(iq)
-      endif !if (nqfils(iq).gt.0) then
+        enddo
+c$OMP END DO NOWAIT
+      enddo
 
 
@@ -895,5 +884,5 @@
       USE parallel_lmdz
       USE vlz_mod
-      USE infotrac, ONLY : nqtot,nqfils,nqdesc,iqfils, ! CRisi                 &
+      USE infotrac, ONLY : nqtot,tracers, ! CRisi                 &
      &                     qperemin,masseqmin,ratiomin ! MVals et CRisi
       
@@ -1159,32 +1148,29 @@
 ! CRisi: appel récursif de l'advection sur les fils.
 ! Il faut faire ça avant d'avoir mis à jour q et masse
-      !write(*,*) 'vlsplt 942: iq,nqfils(iq)=',iq,nqfils(iq)
-      if (nqfils(iq).gt.0) then  
-       do ifils=1,nqdesc(iq)
-       !do ifils=1,nqfils(iq) ! modif C Risi 22 nov 2020
-         iq2=iqfils(ifils,iq)
-c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
-         DO l=1,llm
+      !write(*,*) 'vlsplt 942: iq,nqChilds(iq)=',iq,tracers(iq)%nqChilds
+      do ifils=1,tracers(iq)%nqDescen
+        iq2=tracers(iq)%iqDescen(ifils)
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+        DO l=1,llm
           DO ij=ijb,ije
            !MVals: veiller a ce qu'on n'ait pas de denominateur nul
-           masse(ij,l,iq2)=max(masse(ij,l,iq)*q(ij,l,iq),masseqmin)
-           if (q(ij,l,iq).gt.qperemin) then
-             Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)
-           else
-             Ratio(ij,l,iq2)=ratiomin
-           endif
-           !wq(ij,l,iq2)=wq(ij,l,iq) ! correction bug le 15mai2015
-           w(ij,l,iq2)=wq(ij,l,iq)
+            masse(ij,l,iq2)=max(masse(ij,l,iq)*q(ij,l,iq),masseqmin)
+            if (q(ij,l,iq).gt.qperemin) then
+              Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)
+            else
+              Ratio(ij,l,iq2)=ratiomin
+            endif
+            !wq(ij,l,iq2)=wq(ij,l,iq) ! correction bug le 15mai2015
+            w(ij,l,iq2)=wq(ij,l,iq)
           enddo   
-         enddo
-c$OMP END DO NOWAIT
-        enddo !do ifils=1,nqdesc(iq)
+        enddo
+c$OMP END DO NOWAIT
+      enddo
 c$OMP BARRIER
 
-        do ifils=1,nqfils(iq)
-         iq2=iqfils(ifils,iq)
-         call vlz_loc(Ratio,pente_max,masse,w,ijb_x,ije_x,iq2)
-        enddo !do ifils=1,nqfils(iq)
-      endif !if (nqfils(iq).gt.0) then
+      do ifils=1,tracers(iq)%nqChilds
+        iq2=tracers(iq)%iqDescen(ifils)
+        call vlz_loc(Ratio,pente_max,masse,w,ijb_x,ije_x,iq2)
+      enddo
 ! end CRisi  
 
@@ -1207,16 +1193,14 @@
       
 ! retablir les fils en rapport de melange par rapport a l'air:
-      if (nqfils(iq).gt.0) then  
-       do ifils=1,nqdesc(iq)
-         iq2=iqfils(ifils,iq)  
+      do ifils=1,tracers(iq)%nqDescen
+        iq2=tracers(iq)%iqDescen(ifils)
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)   
-         DO l=1,llm
+        DO l=1,llm
           DO ij=ijb,ije
             q(ij,l,iq2)=q(ij,l,iq)*Ratio(ij,l,iq2)            
           enddo
-         enddo
-c$OMP END DO NOWAIT
-        enddo !do ifils=1,nqdesc(iq)
-      endif !if (nqfils(iq).gt.0) then
+        enddo
+c$OMP END DO NOWAIT
+      enddo
 
       RETURN
Index: /LMDZ6/trunk/libf/dyn3dmem/vlspltgen_loc.F
===================================================================
--- /LMDZ6/trunk/libf/dyn3dmem/vlspltgen_loc.F	(revision 4049)
+++ /LMDZ6/trunk/libf/dyn3dmem/vlspltgen_loc.F	(revision 4050)
@@ -2,5 +2,5 @@
 ! $Header$
 !
-       SUBROUTINE vlspltgen_loc( q,iadv,pente_max,masse,w,pbaru,pbarv,
+       SUBROUTINE vlspltgen_loc( q,pente_max,masse,w,pbaru,pbarv,
      &                           pdt, p,pk,teta                 )
      
@@ -28,6 +28,5 @@
       USE VAMPIR
       ! CRisi: on rajoute variables utiles d'infotrac  
-      USE infotrac, ONLY : nqtot,nqperes,nqdesc,nqfils,iqfils, 
-     &    ok_iso_verif
+      USE infotrac, ONLY : nqtot,nqperes, tracers,ok_iso_verif
       USE vlspltgen_mod
       USE comconst_mod, ONLY: cpp
@@ -41,5 +40,4 @@
 c   Arguments:
 c   ----------
-      INTEGER iadv(nqtot)
       REAL masse(ijb_u:ije_u,llm),pente_max
       REAL pbaru( ijb_u:ije_u,llm ),pbarv( ijb_v:ije_v,llm)
@@ -200,15 +198,12 @@
 !      DO iq=1,nqtot
       DO iq=1,nqperes ! CRisi: on ne boucle que sur les pères= ceux qui sont transportés directement par l'air
-       !write(*,*) 'vlspltgen 192: iq,iadv=',iq,iadv(iq)
+       !write(*,*) 'vlspltgen 192: iq,iadv=',iq,tracers(iq)%iadv
 #ifdef DEBUG_IO    
        CALL WriteField_u('zq',zq(:,:,iq))
        CALL WriteField_u('zm',zm(:,:,iq)) 
 #endif
-        if(iadv(iq) == 0) then
-        
-          cycle 
-        
-        else if (iadv(iq)==10) then
-
+        SELECT CASE(tracers(iq)%iadv)
+          CASE(0); CYCLE
+          CASE(10)
 #ifdef _ADV_HALO        
 ! CRisi: on ajoute les nombres de fils et tableaux des fils
@@ -229,6 +224,6 @@
           call Register_Hallo_u(zm(:,:,iq),llm,1,1,1,1,MyRequest1)
 ! CRisi
-          do ifils=1,nqdesc(iq)
-            iq2=iqfils(ifils,iq)
+          do ifils=1,tracers(iq)%nqDescen
+            iq2=tracers(iq)%iqDescen(ifils)
             call Register_Hallo_u(zq(:,:,iq2),llm,2,2,2,2,MyRequest1)
             call Register_Hallo_u(zm(:,:,iq2),llm,1,1,1,1,MyRequest1)
@@ -238,6 +233,5 @@
           call VTe(VTHallo)
 c$OMP END MASTER
-        else if (iadv(iq)==14) then
-
+          CASE(14)
 #ifdef _ADV_HALO           
           call vlxqs_loc(zq,pente_max,zm,mu,
@@ -256,6 +250,6 @@
           call Register_Hallo_u(zq(:,:,iq),llm,2,2,2,2,MyRequest1)
           call Register_Hallo_u(zm(:,:,iq),llm,1,1,1,1,MyRequest1)
-          do ifils=1,nqdesc(iq)
-            iq2=iqfils(ifils,iq)
+          do ifils=1,tracers(iq)%nqDescen
+            iq2=tracers(iq)%iqDescen(ifils)
             call Register_Hallo_u(zq(:,:,iq2),llm,2,2,2,2,MyRequest1)
             call Register_Hallo_u(zm(:,:,iq2),llm,1,1,1,1,MyRequest1)
@@ -265,9 +259,8 @@
           call VTe(VTHallo)
 c$OMP END MASTER 
-        else
-        
+          CASE DEFAULT
           stop 'vlspltgen_p : schema non parallelise'
       
-        endif
+        END SELECT
       
       enddo !DO iq=1,nqperes
@@ -298,24 +291,20 @@
         !write(*,*) 'vlspltgen 279: iq=',iq
 
-        if(iadv(iq) == 0) then
-        
-          cycle 
-        
-        else if (iadv(iq)==10) then
-
+        SELECT CASE(tracers(iq)%iadv)
+          CASE(0); CYCLE
+          CASE(10)
 #ifdef _ADV_HALLO
           call vlx_loc(zq,pente_max,zm,mu,
      &                 ij_begin+2*iip1,ij_end-2*iip1,iq)
 #endif        
-        else if (iadv(iq)==14) then
+          CASE(14)
 #ifdef _ADV_HALLO
           call vlxqs_loc(zq,pente_max,zm,mu,
      &                    qsat,ij_begin+2*iip1,ij_end-2*iip1,iq)
 #endif    
-        else
-        
+          CASE DEFAULT
           stop 'vlspltgen_p : schema non parallelise'
       
-        endif
+        END SELECT
       
       enddo
@@ -355,22 +344,11 @@
 #endif
 
-        if(iadv(iq) == 0) then
-        
-          cycle 
-        
-        else if (iadv(iq)==10) then
-        
-          call vly_loc(zq,pente_max,zm,mv,iq)
-  
-        else if (iadv(iq)==14) then
-      
-          call vlyqs_loc(zq,pente_max,zm,mv,
-     &                   qsat,iq)
- 
-        else
-        
+        SELECT CASE(tracers(iq)%iadv)
+          CASE(0); CYCLE
+          CASE(10); call vly_loc(zq,pente_max,zm,mv,iq)
+          CASE(14); call vlyqs_loc(zq,pente_max,zm,mv,qsat,iq)
+          CASE DEFAULT
           stop 'vlspltgen_p : schema non parallelise'
-      
-        endif
+        END SELECT
        
        enddo
@@ -386,10 +364,7 @@
        CALL WriteField_u('zm',zm(:,:,iq))
 #endif
-        if(iadv(iq) == 0) then 
-          
-          cycle 
-        
-        else if (iadv(iq)==10 .or. iadv(iq)==14 ) then
-
+        SELECT CASE(tracers(iq)%iadv)
+          CASE(0); CYCLE
+          CASE(10,14)
 c$OMP BARRIER        
 #ifdef _ADV_HALLO
@@ -411,6 +386,6 @@
           call Register_Hallo_u(zm(:,:,iq),llm,1,1,1,1,MyRequest2)
           ! CRisi
-          do ifils=1,nqdesc(iq)
-            iq2=iqfils(ifils,iq)
+          do ifils=1,tracers(iq)%nqDescen
+            iq2=tracers(iq)%iqDescen(ifils)
             call Register_Hallo_u(zq(:,:,iq2),llm,2,2,2,2,MyRequest2)
             call Register_Hallo_u(zm(:,:,iq2),llm,1,1,1,1,MyRequest2)
@@ -420,9 +395,8 @@
 c$OMP END MASTER        
 c$OMP BARRIER
-        else
-        
+          CASE DEFAULT
           stop 'vlspltgen_p : schema non parallelise'
       
-        endif
+        END SELECT
       
       enddo
@@ -448,9 +422,7 @@
       !write(*,*) 'vlspltgen 409: iq=',iq
 
-        if(iadv(iq) == 0) then
-          
-          cycle 
-        
-        else if (iadv(iq)==10 .or. iadv(iq)==14 ) then
+        SELECT CASE(tracers(iq)%iadv)
+          CASE(0); CYCLE
+          CASE(10,14)
 c$OMP BARRIER        
 
@@ -461,9 +433,7 @@
 
 c$OMP BARRIER        
-        else
-        
+          CASE DEFAULT
           stop 'vlspltgen_p : schema non parallelise'
-      
-        endif
+        END SELECT
       
       enddo
@@ -498,22 +468,10 @@
        CALL WriteField_u('zm',zm(:,:,iq))
 #endif
-        if(iadv(iq) == 0) then
-        
-          cycle 
-        
-        else if (iadv(iq)==10) then
-        
-          call vly_loc(zq,pente_max,zm,mv,iq)
-  
-        else if (iadv(iq)==14) then
-      
-          call vlyqs_loc(zq,pente_max,zm,mv,
-     &                   qsat,iq)
- 
-        else
-        
-          stop 'vlspltgen_p : schema non parallelise'
-      
-        endif
+        SELECT CASE(tracers(iq)%iadv)
+          CASE(0); CYCLE
+          CASE(10); call   vly_loc(zq,pente_max,zm,mv,     iq)
+          CASE(14); call vlyqs_loc(zq,pente_max,zm,mv,qsat,iq)
+          CASE DEFAULT; stop 'vlspltgen_p : schema non parallelise'
+        END SELECT
        
        enddo !do iq=1,nqperes
@@ -529,23 +487,12 @@
        CALL WriteField_u('zm',zm(:,:,iq))
 #endif
-        if(iadv(iq) == 0) then 
-          
-          cycle 
-        
-        else if (iadv(iq)==10) then
-        
-          call vlx_loc(zq,pente_max,zm,mu,
+        SELECT CASE(tracers(iq)%iadv)
+          CASE(0); CYCLE
+          CASE(10); call   vlx_loc(zq,pente_max,zm,mu,
      &               ij_begin,ij_end,iq)
-  
-        else if (iadv(iq)==14) then
-      
-          call vlxqs_loc(zq,pente_max,zm,mu,
+          CASE(14); call vlxqs_loc(zq,pente_max,zm,mu,
      &                 qsat, ij_begin,ij_end,iq)
- 
-        else
-        
-          stop 'vlspltgen_p : schema non parallelise'
-      
-        endif
+          CASE DEFAULT; stop 'vlspltgen_p : schema non parallelise'
+        END SELECT
        
        enddo !do iq=1,nqperes
Index: /LMDZ6/trunk/libf/dyn3dmem/vlspltqs_loc.F
===================================================================
--- /LMDZ6/trunk/libf/dyn3dmem/vlspltqs_loc.F	(revision 4049)
+++ /LMDZ6/trunk/libf/dyn3dmem/vlspltqs_loc.F	(revision 4050)
@@ -12,5 +12,5 @@
 c   --------------------------------------------------------------------
       USE parallel_lmdz
-      USE infotrac, ONLY : nqtot,nqfils,nqdesc,iqfils, ! CRisi                 &
+      USE infotrac, ONLY : nqtot,tracers, ! CRisi                 &
      &                     qperemin,masseqmin,ratiomin ! MVals et CRisi
       IMPLICIT NONE
@@ -337,30 +337,28 @@
 ! CRisi: appel récursif de l'advection sur les fils.
 ! Il faut faire ça avant d'avoir mis à jour q et masse
-      !write(*,*) 'vlspltqs 336: iq,ijb_x,nqfils(iq)=',
-!     &     iq,ijb_x,nqfils(iq)  
-
-      if (nqfils(iq).gt.0) then  
-       do ifils=1,nqdesc(iq)
-         iq2=iqfils(ifils,iq)
+      !write(*,*) 'vlspltqs 336: iq,ijb_x,iqDescen(iq)=',
+!     &     iq,ijb_x,tracers(iq)%iqDescen  
+
+      do ifils=1,tracers(iq)%nqDescen
+        iq2=tracers(iq)%iqDescen(ifils)
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)   
-         DO l=1,llm
+        DO l=1,llm
           DO ij=ijb,ije
-           !MVals: veiller a ce qu'on n'ait pas de denominateur nul
-           masse(ij,l,iq2)=max(masse(ij,l,iq)*q(ij,l,iq),masseqmin)
-           if (q(ij,l,iq).gt.qperemin) then ! modif 13 nov 2020
-             Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)
-           else
-             Ratio(ij,l,iq2)=ratiomin
-           endif 
+            !MVals: veiller a ce qu'on n'ait pas de denominateur nul
+            masse(ij,l,iq2)=max(masse(ij,l,iq)*q(ij,l,iq),masseqmin)
+            if (q(ij,l,iq).gt.qperemin) then ! modif 13 nov 2020
+              Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)
+            else
+              Ratio(ij,l,iq2)=ratiomin
+            endif 
           enddo   
-         enddo
-c$OMP END DO NOWAIT
-        enddo !do ifils=1,nqfils(iq)
-        do ifils=1,nqfils(iq)
-         iq2=iqfils(ifils,iq)
-         !write(*,*) 'vlxqs 349: on appelle vlx pour iq2=',iq2
-         call vlx_loc(Ratio,pente_max,masse,u_mq,ijb_x,ije_x,iq2)
-        enddo !do ifils=1,nqfils(iq)
-      endif !if (nqfils(iq).gt.0) then
+        enddo
+c$OMP END DO NOWAIT
+      enddo
+      do ifils=1,tracers(iq)%nqDescen
+        iq2=tracers(iq)%iqDescen(ifils)
+        !write(*,*) 'vlxqs 349: on appelle vlx pour iq2=',iq2
+        call vlx_loc(Ratio,pente_max,masse,u_mq,ijb_x,ije_x,iq2)
+      enddo
 ! end CRisi
 
@@ -389,19 +387,17 @@
 
 ! retablir les fils en rapport de melange par rapport a l'air:
-      if (nqfils(iq).gt.0) then  
-       do ifils=1,nqdesc(iq)
-         iq2=iqfils(ifils,iq)  
+      do ifils=1,tracers(iq)%nqDescen
+        iq2=tracers(iq)%iqDescen(ifils)
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)   
-         DO l=1,llm
+        DO l=1,llm
           DO ij=ijb+1,ije
             q(ij,l,iq2)=q(ij,l,iq)*Ratio(ij,l,iq2)            
           enddo
           DO ij=ijb+iip1-1,ije,iip1
-             q(ij-iim,l,iq2)=q(ij,l,iq2)
+            q(ij-iim,l,iq2)=q(ij,l,iq2)
           enddo ! DO ij=ijb+iip1-1,ije,iip1
-         enddo
-c$OMP END DO NOWAIT
-        enddo !do ifils=1,nqdesc(iq)
-      endif !if (nqfils(iq).gt.0) then
+        enddo
+c$OMP END DO NOWAIT
+      enddo
 
       !write(*,*) 'vlspltqs 399: iq,ijb_x=',iq,ijb_x
@@ -426,5 +422,5 @@
 c   --------------------------------------------------------------------
       USE parallel_lmdz
-      USE infotrac, ONLY : nqtot,nqfils,nqdesc,iqfils, ! CRisi                 &
+      USE infotrac, ONLY : nqtot,tracers, ! CRisi                 &
      &                     qperemin,masseqmin,ratiomin ! MVals et CRisi
       USE comconst_mod, ONLY: pi
@@ -733,5 +729,5 @@
 ! CRisi: appel récursif de l'advection sur les fils.
 ! Il faut faire ça avant d'avoir mis à jour q et masse
-      !write(*,*) 'vlyqs 689: iq,nqfils(iq)=',iq,nqfils(iq)
+      !write(*,*) 'vlyqs 689: iq,iqDescen(iq)=',iq,tracers(iq)%iqDescen
       
       ijb=ij_begin-2*iip1
@@ -747,35 +743,33 @@
       !write(lunout,*) 'ij_begin,ij_end=',ij_begin,ij_end
       !write(lunout,*) 'pole_nord,pole_sud=',pole_nord,pole_sud
-      if (nqfils(iq).gt.0) then  
-       do ifils=1,nqdesc(iq)
-         iq2=iqfils(ifils,iq)
+      do ifils=1,tracers(iq)%nqDescen
+        iq2=tracers(iq)%iqDescen(ifils)
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)   
-         DO l=1,llm
+        DO l=1,llm
           ! modif des bornes: CRisi 16 nov 2020
           ! d'abord masse avec bornes corrigées
           DO ij=ijbm,ijem 
-           !MVals: veiller a ce qu'on n'ait pas de denominateur nul
-           masse(ij,l,iq2)=max(masse(ij,l,iq)*q(ij,l,iq),masseqmin)
+            !MVals: veiller a ce qu'on n'ait pas de denominateur nul
+            masse(ij,l,iq2)=max(masse(ij,l,iq)*q(ij,l,iq),masseqmin)
           enddo !DO ij=ijbm,ijem 
 
           ! ensuite Ratio avec anciennes bornes
           DO ij=ijb,ije
-           !MVals: veiller a ce qu'on n'ait pas de denominateur nul
-           !write(lunout,*) 'ij,l,q(ij,l,iq)=',ij,l,q(ij,l,iq)
-           if (q(ij,l,iq).gt.qperemin) then ! modif 13 nov 2020
-             Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)
-           else
-             Ratio(ij,l,iq2)=ratiomin   
-           endif
+            !MVals: veiller a ce qu'on n'ait pas de denominateur nul
+            !write(lunout,*) 'ij,l,q(ij,l,iq)=',ij,l,q(ij,l,iq)
+            if (q(ij,l,iq).gt.qperemin) then ! modif 13 nov 2020
+              Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)
+            else
+              Ratio(ij,l,iq2)=ratiomin   
+            endif
           enddo !DO ij=ijbm,ijem
-         enddo !DO l=1,llm
-c$OMP END DO NOWAIT
-        enddo !do ifils=1,nqdesc(iq)
-        do ifils=1,nqfils(iq)
-         iq2=iqfils(ifils,iq)
-         !write(lunout,*) 'vly: appel recursiv vly iq2=',iq2
-         call vly_loc(Ratio,pente_max,masse,qbyv,iq2)
-        enddo !do ifils=1,nqfils(iq)
-      endif !if (nqfils(iq).gt.0) then
+        enddo !DO l=1,llm
+c$OMP END DO NOWAIT
+      enddo
+      do ifils=1,tracers(iq)%nqDescen
+        iq2=tracers(iq)%iqDescen(ifils)
+        !write(lunout,*) 'vly: appel recursiv vly iq2=',iq2
+        call vly_loc(Ratio,pente_max,masse,qbyv,iq2)
+      enddo
 
         
@@ -856,16 +850,14 @@
 !      if (pole_sud)  ije=ij_end-iip1
   
-      if (nqfils(iq).gt.0) then  
-       do ifils=1,nqdesc(iq)
-         iq2=iqfils(ifils,iq)  
+      do ifils=1,tracers(iq)%nqDescen
+        iq2=tracers(iq)%iqDescen(ifils)
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)   
-         DO l=1,llm
+        DO l=1,llm
           DO ij=ijb,ije
             q(ij,l,iq2)=q(ij,l,iq)*Ratio(ij,l,iq2)            
           enddo
-         enddo
-c$OMP END DO NOWAIT
-        enddo !do ifils=1,nqdesc(iq)
-      endif !if (nqfils(iq).gt.0) then
+        enddo
+c$OMP END DO NOWAIT
+      enddo
 
 
Index: /LMDZ6/trunk/libf/dyn3dmem/vlz_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/dyn3dmem/vlz_mod.F90	(revision 4049)
+++ /LMDZ6/trunk/libf/dyn3dmem/vlz_mod.F90	(revision 4050)
@@ -5,6 +5,5 @@
   REAL,POINTER,SAVE :: dzqw(:,:)
   REAL,POINTER,SAVE :: adzqw(:,:)
-  ! CRisi: pour les traceurs:  
-  !REAL,POINTER,SAVE :: masseq(:,:,:)
+  ! CRisi: pour les traceurs:
   REAL,POINTER,SAVE :: Ratio(:,:,:)
   
@@ -25,8 +24,5 @@
     CALL allocate_u(dzqw,llm,d)
     CALL allocate_u(adzqw,llm,d)
-    if (nqdesc_tot.gt.0) then
-    !CALL allocate_u(masseq,llm,nqtot,d)
-    CALL allocate_u(Ratio,llm,nqtot,d)
-    endif !if (nqdesc_tot.gt.0) then
+    IF(ANY(tracers(:)%nqDescen > 0)) CALL allocate_u(Ratio,llm,nqtot,d)
 
   END SUBROUTINE vlz_allocate
@@ -44,9 +40,5 @@
     CALL switch_u(dzqw,distrib_vanleer,dist)
     CALL switch_u(adzqw,distrib_vanleer,dist)
-    ! CRisi:
-    if (nqdesc_tot.gt.0) then    
-    !CALL switch_u(masseq,distrib_vanleer,dist)
-    CALL switch_u(Ratio,distrib_vanleer,dist)
-    endif !if (nqdesc_tot.gt.0) then     
+    IF(ANY(tracers(:)%nqDescen > 0)) CALL switch_u(Ratio,distrib_vanleer,dist)
 
   END SUBROUTINE vlz_switch_vanleer  
Index: /LMDZ6/trunk/libf/dynphy_lonlat/phylmd/etat0dyn_netcdf.F90
===================================================================
--- /LMDZ6/trunk/libf/dynphy_lonlat/phylmd/etat0dyn_netcdf.F90	(revision 4049)
+++ /LMDZ6/trunk/libf/dynphy_lonlat/phylmd/etat0dyn_netcdf.F90	(revision 4050)
@@ -150,6 +150,6 @@
     CALL regr_lat_time_coefoz
     CALL press_coefoz
-    CALL regr_pr_o3(p3d, q3d(:,:,:,i))
-    q3d(:,:,:,i)=q3d(:,:,:,i)*48./ 29.                  !--- Mole->mass fraction         
+    CALL regr_pr_o3(p3d, q3d(:,:,:,iq))
+    q3d(:,:,:,iq)=q3d(:,:,:,iq)*48./ 29.                !--- Mole->mass fraction         
   END IF
 #endif
Index: /LMDZ6/trunk/libf/dynphy_lonlat/phylmd/iniphysiq_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/dynphy_lonlat/phylmd/iniphysiq_mod.F90	(revision 4049)
+++ /LMDZ6/trunk/libf/dynphy_lonlat/phylmd/iniphysiq_mod.F90	(revision 4050)
@@ -18,9 +18,7 @@
   USE infotrac, ONLY: nqtot,nqo,nbtr,nqCO2,tracers,type_trac,&
                       niadv,conv_flg,pbl_flg,solsym,&
-                      nqfils,nqdesc,nqdesc_tot,iqfils,iqpere,&
                       ok_isotopes,ok_iso_verif,ok_isotrac,&
                       ok_init_iso,niso_possibles,tnat,&
-                      alpha_ideal,use_iso,iqiso,iso_num,&
-                      iso_indnum,zone_num,phase_num,&
+                      alpha_ideal,use_iso,iqiso,iso_indnum,&
                       indnum_fn_num,index_trac,&
                       niso,ntraceurs_zone,ntraciso,nqtottr,itr_indice
@@ -148,9 +146,7 @@
   CALL init_infotrac_phy(nqtot,nqo,nbtr,nqtottr,nqCO2,tracers,type_trac,&
                          niadv,conv_flg,pbl_flg,solsym,&
-                         nqfils,nqdesc,nqdesc_tot,iqfils,iqpere,&
                          ok_isotopes,ok_iso_verif,ok_isotrac,&
                          ok_init_iso,niso_possibles,tnat,&
-                         alpha_ideal,use_iso,iqiso,iso_num,&
-                         iso_indnum,zone_num,phase_num,&
+                         alpha_ideal,use_iso,iqiso,iso_indnum,&
                          indnum_fn_num,index_trac,&
                          niso,ntraceurs_zone,ntraciso,itr_indice &
